#!/bin/bash
#
# Goes through directories inside ~/marignatios, checks whether any are
# ready to upload through the presence of an "ok" directory, and if so,
# sends them to smugmug.
#
# See /etc/cron.d/clean-marignatios-uploads for the jobused to clean up these
# entries after a period in time
#
#set -x
for d in ~/marignatios/*; do
    if [ -d "$d/ok" ]; then
	# remove ok so if the upload takes a while
	# it doesn't keep on getting found
        rmdir $d/ok
        cd $d
        mkdir sending
	# remove duplicates that f-spot creates
	# XXX this leaves behind duplicates when there are multiple 
	# modified copies
	for f in `ls *\ \(* 2> /dev/null | cut -d_ -f2 | cut -d" " -f1`; do \
		rm -f IMG_$f.*; done
        # enable -k when the time has come
        ~/bin/upload.sh -a "`basename $d`" *.JPG *.jpg >& log
	rmdir sending
        mkdir finito
    fi
    if echo $d | grep -qs -- '-ok\.zip$'; then
	mv $d /var/www/marignatios.com/content/tmp/
	zip=$(basename $d)
	chmod 644 /var/www/marignatios.com/content/tmp/$zip
    fi
done
