#!/bin/bash
# We have to do this because:
#  - Smugmug reads from the IPTC:Keywords and XMP:Subject fields
#  - F-Spot 0.8.0 stores comments in the XMP:UserComment field, and tags in
#  	the XMP:Subject field
#  - F-Spot 0.6.1 stores comments in the IPTC:UserComment field
#	This means we can't use $XMP:UserComment if we want to be
#	backwards-compatible; check if this works across the board
#  - F-Spot 0.8.0 messes up IPTC data, so we need to be careful to use the XMP
#    	content as input.
#  - Smugmug reads captions from:
#	- EXIF:ImageDescription
#	- IPTC:Caption-Abstract
set -x

# From nautilus-image-properties-page.c
#
# append_xmp_value_pair (page, xmp, NS_IPTC4XMP, "Location", _("Location"));
# append_xmp_value_pair (page, xmp, NS_DC, "description", _("Description"));
# append_xmp_value_pair (page, xmp, NS_DC, "subject", _("Keywords"));
# append_xmp_value_pair (page, xmp, NS_DC, "creator", _("Creator"));
# append_xmp_value_pair (page, xmp, NS_DC, "rights", _("Copyright"));
# append_xmp_value_pair (page, xmp, NS_XAP,"Rating", _("Rating"));

# XXX: use cameratype to differentiate
ARTIST="Mari Ignatios"
WEBSITE="www.marignatios.com"
COPYRIGHT="© $ARTIST"

#ARTIST="Cadu Rolim"
#WEBSITE="www.marignatios.com"
#COPYRIGHT="© $ARTIST ($WEBSITE)"

#ARTIST="Carlos Eduardo Rodrigues da Silva"
#WEBSITE="www.marignatios.com"
#COPYRIGHT="© $ARTIST"

exiftool -fast -P -overwrite_original -m \
    -'EXIF:Artist'="$ARTIST" \
    -'EXIF:Copyright'="$COPYRIGHT" \
    -'XMP:OwnerName'="$ARTIST" \
    -'XMP:WebStatement'="$WEBSITE" \
    -'IPTC:By-line'="$ARTIST / $WEBSITE" \
    -'IPTC:Country-PrimaryLocationCode'="BRA" \
    -'IPTC:Country-PrimaryLocationName'="Brasil" \
    -'IPTC:Keywords<$XMP:UserComment,$XMP:Subject' \
    -'EXIF:ImageDescription'= \
    -'XMP:Description'= \
    -'IPTC:Caption-Abstract<$File:Filename '"$COPYRIGHT" \
    "$*"

# Recreates IPTC to avoid warnings
#-IPTC:all= -@ /usr/share/libimage-exiftool-perl/xmp2iptc.args \
# Recreated by IPTC:all
#-'IPTC:Caption-Abstract'= \


# EXIF:Artist
#   Mariana Ignatios
# EXIF:Copyright
#    © Mariana Ignatios
# XMP:OwnerName
#   Mariana Ignatios
# XMP:WebStatement
#   www.marignatios.com
# IPTC:By-line
#   Mariana Ignatios / www.marignatios.com
# IPTC:Country-PrimaryLocationCode
#   BRA
# IPTC:Country-PrimaryLocationName
#   Brasil
# XXX: IPTC "City": "S‹o Carlos",
# XXX: IPTC "Province-State": "SP",
# XXX: IPTC Headline

